package com.example.fuzzControll.tools;

import com.alibaba.fastjson.JSONObject;
import com.example.fuzzControll.exception.AflnetException;
import com.example.fuzzControll.exception.CmdException;
import com.example.fuzzControll.pojo.vo.*;
import lombok.extern.slf4j.Slf4j;
import org.springframework.transaction.annotation.Transactional;

import java.io.*;

import java.util.*;
import java.util.stream.Collectors;


//todo need modify
@Slf4j
public class CmdTools {

    Boolean show = true;

    /**
     * 运行不需要后台运行cmd
     */
    public List<String> runCmd(String cmd, String caller) throws CmdException {
        List<String> result = new ArrayList<String>();
        try {
            Process process = Runtime.getRuntime().exec(cmd);
            printMessage(process.getInputStream(), result);
            printMessage(process.getErrorStream(), new ArrayList<String>());
            process.waitFor();
        } catch (Exception e) {
            e.printStackTrace();
            throw new CmdException(caller + " run cmd failed!");
        }

        return result;
    }
    //todo 不同协议种子路径也不同

    /**
     * 运行需要后台运行cmd
     * 通过websocket返回数据
     */
    public void runProgramCmd(String cmd, String outputFileName) throws AflnetException {
        try {
            Process process = Runtime.getRuntime().exec(cmd);
            printMessageToCmd(process.getInputStream());
            printMessage(process.getErrorStream(), new ArrayList<String>());
            process.waitFor();
            log.info("Aflnet cmd have been run.");
        } catch (Exception e) {
            e.printStackTrace();
            throw new AflnetException("Aflnet run error");
        }
    }


    private List<String> printMessage(final InputStream input, final List<String> result) {
        new Thread(new Runnable() {
            @Override
            public void run() {
                Reader reader = new InputStreamReader(input);
                BufferedReader bf = new BufferedReader(reader);
                String line = null;
                try {
                    while ((line = bf.readLine()) != null) {
                        result.add(line);
                    }
                } catch (IOException e) {
                    e.printStackTrace();
                }

            }
        }).start();
        return result;
    }

    private void printMessageToCmd(final InputStream input) throws IOException, AflnetException {
        show = true;
        Reader reader = new InputStreamReader(input);
        BufferedReader bf = new BufferedReader(reader);
        String line = null;
        while ((line = bf.readLine()) != null && TestControlTools.getIsRunning()) {
            System.out.println(line);
        }
    }


    public String parse(CmdStartParams cmdStartParams) throws AflnetException {
        if (cmdStartParams == null) {
            throw new AflnetException("CmdStartParams is null !");
        }
        StringBuilder cmd = new StringBuilder();
        if (cmdStartParams.getNetinfo() != "" && cmdStartParams.getNetinfo() != null) {
            cmd.append(" -N " + cmdStartParams.getNetinfo());
        } else {
            log.error("There is no netinfo !");
            throw new AflnetException("There is no netinfo !");
        }
        if (cmdStartParams.getProtopcol() != "") {
            cmd.append(" -P " + cmdStartParams.getProtopcol());
        }
        if (cmdStartParams.getWaiting() != 0) {
            cmd.append(" -D " + cmdStartParams.getWaiting());
        }
        if (cmdStartParams.getNsname() != "") {
            cmd.append(" -e " + cmdStartParams.getNsname());
        }
        if (cmdStartParams.getKill()) {
            cmd.append(" -K ");
        }
        if (cmdStartParams.getAwareMode()) {
            cmd.append(" -E ");
        }
        if (cmdStartParams.getRegionMutationOperators()) {
            cmd.append(" -R ");
        }
        if (cmdStartParams.getFalseNegativeMode()) {
            cmd.append(" -F ");
        }
        if (cmdStartParams.getScript() != "") {
            cmd.append(" -c " + cmdStartParams.getScript());
        }
        if (cmdStartParams.getStateSelectionAlgo() != 0) {
            cmd.append(" -q " + cmdStartParams.getStateSelectionAlgo());
        }
        if (cmdStartParams.getSeedSelectionAlgo() != 0) {
            cmd.append(" -s " + cmdStartParams.getSeedSelectionAlgo() + " ");
        }
        return cmd.toString();
    }

}